JSONObject (JSON in Java 20240205 API)

Package org.json

## Class JSONObject

- java.lang.Object
- - org.json.JSONObject

-     public class JSONObject
      extends Object

  A JSONObject is an unordered collection of name/value pairs. Its external form is a string wrapped in curly braces with colons between the names and values, and commas between the values and names. The internal form is an object having `get` and `opt` methods for accessing the values by name, and `put` methods for adding or replacing values by name. The values can be any of these types: `Boolean`, `JSONArray`, `JSONObject`, `Number`, `String`, or the `JSONObject.NULL` object. A JSONObject constructor can be used to convert an external form JSON text into an internal form whose values can be retrieved with the `get` and `opt` methods, or to convert values into a JSON text using the `put` and `toString` methods. A `get` method returns a value if one can be found, and throws an exception if one cannot be found. An `opt` method returns a default value instead of throwing an exception, and so is useful for obtaining optional values.

  The generic `get()` and `opt()` methods return an object, which you can cast or query for type. There are also typed `get` and `opt` methods that do type checking and type coercion for you. The opt methods differ from the get methods in that they do not throw. Instead, they return a specified value, such as null.

  The `put` methods add or replace values in an object. For example,

       myString = new JSONObject()
               .put("JSON", "Hello, World!").toString();

  produces the string `{"JSON": "Hello, World"}`.

  The texts produced by the `toString` methods strictly conform to the JSON syntax rules. The constructors are more forgiving in the texts they will accept:

  - An extra `,` (comma) may appear just before the closing brace.
  - Strings may be quoted with `'` (single quote).
  - Strings do not need to be quoted at all if they do not begin with a quote or single quote, and if they do not contain leading or trailing spaces, and if they do not contain any of these characters: `{ } [ ] / \ : , #` and if they do not look like numbers and if they are not the reserved words `true`, `false`, or `null`.
  Version:
    2016-08-15
  Author:
    JSON.org

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static Object` | `NULL` | It is sometimes more convenient and less ambiguous to have a `NULL` object than to use Java's `null` value.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `` | `JSONObject()` | Construct an empty JSONObject.
    `protected` | `JSONObject​(int initialCapacity)` | Constructor to specify an initial capacity of the internal map.
    `` | `JSONObject​(Object bean)` | Construct a JSONObject from an Object using bean getters.
    `` | `JSONObject​(Object object, String... names)` | Construct a JSONObject from an Object, using reflection to find the public members.
    `` | `JSONObject​(String source)` | Construct a JSONObject from a source JSON text string.
    `` | `JSONObject​(String baseName, Locale locale)` | Construct a JSONObject from a ResourceBundle.
    `` | `JSONObject​(Map<?,​?> m)` | Construct a JSONObject from a Map.
    `` | `JSONObject​(Map<?,​?> m, JSONParserConfiguration jsonParserConfiguration)` | Construct a JSONObject from a Map with custom json parse configurations.
    `` | `JSONObject​(JSONObject jo, String... names)` | Construct a JSONObject from a subset of another JSONObject.
    `` | `JSONObject​(JSONTokener x)` | Construct a JSONObject from a JSONTokener.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `JSONObject` | `accumulate​(String key, Object value)` | Accumulate values under a key.
    `JSONObject` | `append​(String key, Object value)` | Append values to the array under a key.
    `void` | `clear()` | Removes all of the elements from this JSONObject.
    `static String` | `doubleToString​(double d)` | Produce a string from a double.
    `protected Set<Map.Entry<String,​Object>>` | `entrySet()` | Get a set of entries of the JSONObject.
    `Object` | `get​(String key)` | Get the value object associated with a key.
    `BigDecimal` | `getBigDecimal​(String key)` | Get the BigDecimal value associated with a key.
    `BigInteger` | `getBigInteger​(String key)` | Get the BigInteger value associated with a key.
    `boolean` | `getBoolean​(String key)` | Get the boolean value associated with a key.
    `double` | `getDouble​(String key)` | Get the double value associated with a key.
    `<E extends Enum<E>> E` | `getEnum​(Class<E> clazz, String key)` | Get the enum value associated with a key.
    `float` | `getFloat​(String key)` | Get the float value associated with a key.
    `int` | `getInt​(String key)` | Get the int value associated with a key.
    `JSONArray` | `getJSONArray​(String key)` | Get the JSONArray value associated with a key.
    `JSONObject` | `getJSONObject​(String key)` | Get the JSONObject value associated with a key.
    `long` | `getLong​(String key)` | Get the long value associated with a key.
    `Class<? extends Map>` | `getMapType()` |
    `static String[]` | `getNames​(Object object)` | Get an array of public field names from an Object.
    `static String[]` | `getNames​(JSONObject jo)` | Get an array of field names from a JSONObject.
    `Number` | `getNumber​(String key)` | Get the Number value associated with a key.
    `String` | `getString​(String key)` | Get the string associated with a key.
    `boolean` | `has​(String key)` | Determine if the JSONObject contains a specific key.
    `JSONObject` | `increment​(String key)` | Increment a property of a JSONObject.
    `protected static boolean` | `isDecimalNotation​(String val)` | Tests if the value should be tried as a decimal.
    `boolean` | `isEmpty()` | Check if JSONObject is empty.
    `boolean` | `isNull​(String key)` | Determine if the value associated with the key is `null` or if there is no value.
    `Iterator<String>` | `keys()` | Get an enumeration of the keys of the JSONObject.
    `Set<String>` | `keySet()` | Get a set of keys of the JSONObject.
    `int` | `length()` | Get the number of keys stored in the JSONObject.
    `JSONArray` | `names()` | Produce a JSONArray containing the names of the elements of this JSONObject.
    `static String` | `numberToString​(Number number)` | Produce a string from a Number.
    `Object` | `opt​(String key)` | Get an optional value associated with a key.
    `BigDecimal` | `optBigDecimal​(String key, BigDecimal defaultValue)` | Get an optional BigDecimal associated with a key, or the defaultValue if there is no such key or if its value is not a number.
    `BigInteger` | `optBigInteger​(String key, BigInteger defaultValue)` | Get an optional BigInteger associated with a key, or the defaultValue if there is no such key or if its value is not a number.
    `boolean` | `optBoolean​(String key)` | Get an optional boolean associated with a key.
    `boolean` | `optBoolean​(String key, boolean defaultValue)` | Get an optional boolean associated with a key.
    `Boolean` | `optBooleanObject​(String key)` | Get an optional boolean object associated with a key.
    `Boolean` | `optBooleanObject​(String key, Boolean defaultValue)` | Get an optional boolean object associated with a key.
    `double` | `optDouble​(String key)` | Get an optional double associated with a key, or NaN if there is no such key or if its value is not a number.
    `double` | `optDouble​(String key, double defaultValue)` | Get an optional double associated with a key, or the defaultValue if there is no such key or if its value is not a number.
    `Double` | `optDoubleObject​(String key)` | Get an optional Double object associated with a key, or NaN if there is no such key or if its value is not a number.
    `Double` | `optDoubleObject​(String key, Double defaultValue)` | Get an optional Double object associated with a key, or the defaultValue if there is no such key or if its value is not a number.
    `<E extends Enum<E>> E` | `optEnum​(Class<E> clazz, String key)` | Get the enum value associated with a key.
    `<E extends Enum<E>> E` | `optEnum​(Class<E> clazz, String key, E defaultValue)` | Get the enum value associated with a key.
    `float` | `optFloat​(String key)` | Get the optional float value associated with an index.
    `float` | `optFloat​(String key, float defaultValue)` | Get the optional float value associated with an index.
    `Float` | `optFloatObject​(String key)` | Get the optional Float object associated with an index.
    `Float` | `optFloatObject​(String key, Float defaultValue)` | Get the optional Float object associated with an index.
    `int` | `optInt​(String key)` | Get an optional int value associated with a key, or zero if there is no such key or if the value is not a number.
    `int` | `optInt​(String key, int defaultValue)` | Get an optional int value associated with a key, or the default if there is no such key or if the value is not a number.
    `Integer` | `optIntegerObject​(String key)` | Get an optional Integer object associated with a key, or zero if there is no such key or if the value is not a number.
    `Integer` | `optIntegerObject​(String key, Integer defaultValue)` | Get an optional Integer object associated with a key, or the default if there is no such key or if the value is not a number.
    `JSONArray` | `optJSONArray​(String key)` | Get an optional JSONArray associated with a key.
    `JSONArray` | `optJSONArray​(String key, JSONArray defaultValue)` | Get an optional JSONArray associated with a key, or the default if there is no such key, or if its value is not a JSONArray.
    `JSONObject` | `optJSONObject​(String key)` | Get an optional JSONObject associated with a key.
    `JSONObject` | `optJSONObject​(String key, JSONObject defaultValue)` | Get an optional JSONObject associated with a key, or the default if there is no such key or if the value is not a JSONObject.
    `long` | `optLong​(String key)` | Get an optional long value associated with a key, or zero if there is no such key or if the value is not a number.
    `long` | `optLong​(String key, long defaultValue)` | Get an optional long value associated with a key, or the default if there is no such key or if the value is not a number.
    `Long` | `optLongObject​(String key)` | Get an optional Long object associated with a key, or zero if there is no such key or if the value is not a number.
    `Long` | `optLongObject​(String key, Long defaultValue)` | Get an optional Long object associated with a key, or the default if there is no such key or if the value is not a number.
    `Number` | `optNumber​(String key)` | Get an optional `Number` value associated with a key, or `null` if there is no such key or if the value is not a number.
    `Number` | `optNumber​(String key, Number defaultValue)` | Get an optional `Number` value associated with a key, or the default if there is no such key or if the value is not a number.
    `Object` | `optQuery​(String jsonPointer)` | Queries and returns a value from this object using `jsonPointer`, or returns null if the query fails due to a missing key.
    `Object` | `optQuery​(JSONPointer jsonPointer)` | Queries and returns a value from this object using `jsonPointer`, or returns null if the query fails due to a missing key.
    `String` | `optString​(String key)` | Get an optional string associated with a key.
    `String` | `optString​(String key, String defaultValue)` | Get an optional string associated with a key.
    `JSONObject` | `put​(String key, boolean value)` | Put a key/boolean pair in the JSONObject.
    `JSONObject` | `put​(String key, double value)` | Put a key/double pair in the JSONObject.
    `JSONObject` | `put​(String key, float value)` | Put a key/float pair in the JSONObject.
    `JSONObject` | `put​(String key, int value)` | Put a key/int pair in the JSONObject.
    `JSONObject` | `put​(String key, long value)` | Put a key/long pair in the JSONObject.
    `JSONObject` | `put​(String key, Object value)` | Put a key/value pair in the JSONObject.
    `JSONObject` | `put​(String key, Collection<?> value)` | Put a key/value pair in the JSONObject, where the value will be a JSONArray which is produced from a Collection.
    `JSONObject` | `put​(String key, Map<?,​?> value)` | Put a key/value pair in the JSONObject, where the value will be a JSONObject which is produced from a Map.
    `JSONObject` | `putOnce​(String key, Object value)` | Put a key/value pair in the JSONObject, but only if the key and the value are both non-null, and only if there is not already a member with that name.
    `JSONObject` | `putOpt​(String key, Object value)` | Put a key/value pair in the JSONObject, but only if the key and the value are both non-null.
    `Object` | `query​(String jsonPointer)` | Creates a JSONPointer using an initialization string and tries to match it to an item within this JSONObject.
    `Object` | `query​(JSONPointer jsonPointer)` | Uses a user initialized JSONPointer and tries to match it to an item within this JSONObject.
    `static String` | `quote​(String string)` | Produce a string in double quotes with backslash sequences in all the right places.
    `static Writer` | `quote​(String string, Writer w)` |
    `Object` | `remove​(String key)` | Remove a name and its value, if present.
    `boolean` | `similar​(Object other)` | Determine if two JSONObjects are similar.
    `static Object` | `stringToValue​(String string)` | Try to convert a string into a number, boolean, or null.
    `static void` | `testValidity​(Object o)` | Throw an exception if the object is a NaN or infinite number.
    `JSONArray` | `toJSONArray​(JSONArray names)` | Produce a JSONArray containing the values of the members of this JSONObject.
    `Map<String,​Object>` | `toMap()` | Returns a java.util.Map containing all of the entries in this object.
    `String` | `toString()` | Make a JSON text of this JSONObject.
    `String` | `toString​(int indentFactor)` | Make a pretty-printed JSON text of this JSONObject.
    `static String` | `valueToString​(Object value)` | Make a JSON text of an Object value.
    `static Object` | `wrap​(Object object)` | Wrap an object, if necessary.
    `Writer` | `write​(Writer writer)` | Write the contents of the JSONObject as JSON text to a writer.
    `Writer` | `write​(Writer writer, int indentFactor, int indent)` | Write the contents of the JSONObject as JSON text to a writer.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### NULL

          public static final Object NULL

      It is sometimes more convenient and less ambiguous to have a `NULL` object than to use Java's `null` value. `JSONObject.NULL.equals(null)` returns `true`. `JSONObject.NULL.toString()` returns `"null"`.

  - ### Constructor Detail

    - #### JSONObject

          public JSONObject()

      Construct an empty JSONObject.

    - #### JSONObject

          public JSONObject​(JSONObject jo,
                            String... names)

      Construct a JSONObject from a subset of another JSONObject. An array of strings is used to identify the keys that should be copied. Missing keys are ignored.
      Parameters:
        `jo` - A JSONObject.
        `names` - An array of strings.

    - #### JSONObject

          public JSONObject​(JSONTokener x)
                     throws JSONException

      Construct a JSONObject from a JSONTokener.
      Parameters:
        `x` - A JSONTokener object containing the source string.
      Throws:
        `JSONException` - If there is a syntax error in the source string or a duplicated key.

    - #### JSONObject

          public JSONObject​(Map<?,​?> m)

      Construct a JSONObject from a Map.
      Parameters:
        `m` - A map object that can be used to initialize the contents of the JSONObject.
      Throws:
        `JSONException` - If a value in the map is non-finite number.
        `NullPointerException` - If a key in the map is `null`

    - #### JSONObject

          public JSONObject​(Map<?,​?> m,
                            JSONParserConfiguration jsonParserConfiguration)

      Construct a JSONObject from a Map with custom json parse configurations.
      Parameters:
        `m` - A map object that can be used to initialize the contents of the JSONObject.
        `jsonParserConfiguration` - Variable to pass parser custom configuration for json parsing.

    - #### JSONObject

          public JSONObject​(Object bean)

      Construct a JSONObject from an Object using bean getters. It reflects on all of the public methods of the object. For each of the methods with no parameters and a name starting with `"get"` or `"is"` followed by an uppercase letter, the method is invoked, and a key and the value returned from the getter method are put into the new JSONObject.

      The key is formed by removing the `"get"` or `"is"` prefix. If the second remaining character is not upper case, then the first character is converted to lower case.

      Methods that are `static`, return `void`, have parameters, or are "bridge" methods, are ignored.

      For example, if an object has a method named `"getName"`, and if the result of calling `object.getName()` is `"Larry Fine"`, then the JSONObject will contain `"name": "Larry Fine"`.

      The `JSONPropertyName` annotation can be used on a bean getter to override key name used in the JSONObject. For example, using the object above with the `getName` method, if we annotated it with:

           @JSONPropertyName("FullName")
           public String getName() { return this.name; }

      The resulting JSON object would contain `"FullName": "Larry Fine"`

      Similarly, the `JSONPropertyName` annotation can be used on non- `get` and `is` methods. We can also override key name used in the JSONObject as seen below even though the field would normally be ignored:

           @JSONPropertyName("FullName")
           public String fullName() { return this.name; }

      The resulting JSON object would contain `"FullName": "Larry Fine"`

      The `JSONPropertyIgnore` annotation can be used to force the bean property to not be serialized into JSON. If both `JSONPropertyIgnore` and `JSONPropertyName` are defined on the same method, a depth comparison is performed and the one closest to the concrete class being serialized is used. If both annotations are at the same level, then the `JSONPropertyIgnore` annotation takes precedent and the field is not serialized. For example, the following declaration would prevent the `getName` method from being serialized:

           @JSONPropertyName("FullName")
           @JSONPropertyIgnore
           public String getName() { return this.name; }

      Parameters:
        `bean` - An object that has getter methods that should be used to make a JSONObject.
      Throws:
        `JSONException` - If a getter returned a non-finite number.

    - #### JSONObject

          public JSONObject​(Object object,
                            String... names)

      Construct a JSONObject from an Object, using reflection to find the public members. The resulting JSONObject's keys will be the strings from the names array, and the values will be the field values associated with those keys in the object. If a key is not found or not visible, then it will not be copied into the new JSONObject.
      Parameters:
        `object` - An object that has fields that should be used to make a JSONObject.
        `names` - An array of strings, the names of the fields to be obtained from the object.

    - #### JSONObject

          public JSONObject​(String source)
                     throws JSONException

      Construct a JSONObject from a source JSON text string. This is the most commonly used JSONObject constructor.
      Parameters:
        `source` - A string beginning with `{` (left brace) and ending with `}` (right brace).
      Throws:
        `JSONException` - If there is a syntax error in the source string or a duplicated key.

    - #### JSONObject

          public JSONObject​(String baseName,
                            Locale locale)
                     throws JSONException

      Construct a JSONObject from a ResourceBundle.
      Parameters:
        `baseName` - The ResourceBundle base name.
        `locale` - The Locale to load the ResourceBundle for.
      Throws:
        `JSONException` - If any JSONExceptions are detected.

    - #### JSONObject

          protected JSONObject​(int initialCapacity)

      Constructor to specify an initial capacity of the internal map. Useful for library internal calls where we know, or at least can best guess, how big this JSONObject will be.
      Parameters:
        `initialCapacity` - initial capacity of the internal map.

  - ### Method Detail

    - #### getMapType

          public Class<? extends Map> getMapType()

    - #### accumulate

          public JSONObject accumulate​(String key,
                                       Object value)
                                throws JSONException

      Accumulate values under a key. It is similar to the put method except that if there is already an object stored under the key then a JSONArray is stored under the key to hold all of the accumulated values. If there is already a JSONArray, then the new value is appended to it. In contrast, the put method replaces the previous value. If only one value is accumulated that is not a JSONArray, then the result will be the same as using put. But if multiple values are accumulated, then the result will be like append.
      Parameters:
        `key` - A key string.
        `value` - An object to be accumulated under the key.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### append

          public JSONObject append​(String key,
                                   Object value)
                            throws JSONException

      Append values to the array under a key. If the key does not exist in the JSONObject, then the key is put in the JSONObject with its value being a JSONArray containing the value parameter. If the key was already associated with a JSONArray, then the value parameter is appended to it.
      Parameters:
        `key` - A key string.
        `value` - An object to be accumulated under the key.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number or if the current value associated with the key is not a JSONArray.
        `NullPointerException` - If the key is `null`.

    - #### doubleToString

          public static String doubleToString​(double d)

      Produce a string from a double. The string "null" will be returned if the number is not finite.
      Parameters:
        `d` - A double.
      Returns:
        A String.

    - #### get

          public Object get​(String key)
                     throws JSONException

      Get the value object associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The object associated with the key.
      Throws:
        `JSONException` - if the key is not found.

    - #### getEnum

          public <E extends Enum<E>> E getEnum​(Class<E> clazz,
                                               String key)
                                        throws JSONException

      Get the enum value associated with a key.
      Type Parameters:
        `E` - Enum Type
      Parameters:
        `clazz` - The type of enum to retrieve.
        `key` - A key string.
      Returns:
        The enum value associated with the key
      Throws:
        `JSONException` - if the key is not found or if the value cannot be converted to an enum.

    - #### getBoolean

          public boolean getBoolean​(String key)
                             throws JSONException

      Get the boolean value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The truth.
      Throws:
        `JSONException` - if the value is not a Boolean or the String "true" or "false".

    - #### getBigInteger

          public BigInteger getBigInteger​(String key)
                                   throws JSONException

      Get the BigInteger value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The numeric value.
      Throws:
        `JSONException` - if the key is not found or if the value cannot be converted to BigInteger.

    - #### getBigDecimal

          public BigDecimal getBigDecimal​(String key)
                                   throws JSONException

      Get the BigDecimal value associated with a key. If the value is float or double, the `BigDecimal(double)` constructor will be used. See notes on the constructor for conversion issues that may arise.
      Parameters:
        `key` - A key string.
      Returns:
        The numeric value.
      Throws:
        `JSONException` - if the key is not found or if the value cannot be converted to BigDecimal.

    - #### getDouble

          public double getDouble​(String key)
                           throws JSONException

      Get the double value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The numeric value.
      Throws:
        `JSONException` - if the key is not found or if the value is not a Number object and cannot be converted to a number.

    - #### getFloat

          public float getFloat​(String key)
                         throws JSONException

      Get the float value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The numeric value.
      Throws:
        `JSONException` - if the key is not found or if the value is not a Number object and cannot be converted to a number.

    - #### getNumber

          public Number getNumber​(String key)
                           throws JSONException

      Get the Number value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The numeric value.
      Throws:
        `JSONException` - if the key is not found or if the value is not a Number object and cannot be converted to a number.

    - #### getInt

          public int getInt​(String key)
                     throws JSONException

      Get the int value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The integer value.
      Throws:
        `JSONException` - if the key is not found or if the value cannot be converted to an integer.

    - #### getJSONArray

          public JSONArray getJSONArray​(String key)
                                 throws JSONException

      Get the JSONArray value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        A JSONArray which is the value.
      Throws:
        `JSONException` - if the key is not found or if the value is not a JSONArray.

    - #### getJSONObject

          public JSONObject getJSONObject​(String key)
                                   throws JSONException

      Get the JSONObject value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        A JSONObject which is the value.
      Throws:
        `JSONException` - if the key is not found or if the value is not a JSONObject.

    - #### getLong

          public long getLong​(String key)
                       throws JSONException

      Get the long value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The long value.
      Throws:
        `JSONException` - if the key is not found or if the value cannot be converted to a long.

    - #### getNames

          public static String[] getNames​(JSONObject jo)

      Get an array of field names from a JSONObject.
      Parameters:
        `jo` - JSON object
      Returns:
        An array of field names, or null if there are no names.

    - #### getNames

          public static String[] getNames​(Object object)

      Get an array of public field names from an Object.
      Parameters:
        `object` - object to read
      Returns:
        An array of field names, or null if there are no names.

    - #### getString

          public String getString​(String key)
                           throws JSONException

      Get the string associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        A string which is the value.
      Throws:
        `JSONException` - if there is no string value for the key.

    - #### has

          public boolean has​(String key)

      Determine if the JSONObject contains a specific key.
      Parameters:
        `key` - A key string.
      Returns:
        true if the key exists in the JSONObject.

    - #### increment

          public JSONObject increment​(String key)
                               throws JSONException

      Increment a property of a JSONObject. If there is no such property, create one with a value of 1 (Integer). If there is such a property, and if it is an Integer, Long, Double, Float, BigInteger, or BigDecimal then add one to it. No overflow bounds checking is performed, so callers should initialize the key prior to this call with an appropriate type that can handle the maximum expected value.
      Parameters:
        `key` - A key string.
      Returns:
        this.
      Throws:
        `JSONException` - If there is already a property with this name that is not an Integer, Long, Double, or Float.

    - #### isNull

          public boolean isNull​(String key)

      Determine if the value associated with the key is `null` or if there is no value.
      Parameters:
        `key` - A key string.
      Returns:
        true if there is no value associated with the key or if the value is the JSONObject.NULL object.

    - #### keys

          public Iterator<String> keys()

      Get an enumeration of the keys of the JSONObject. Modifying this key Set will also modify the JSONObject. Use with caution.
      Returns:
        An iterator of the keys.
      See Also:
        `Set.iterator()`

    - #### keySet

          public Set<String> keySet()

      Get a set of keys of the JSONObject. Modifying this key Set will also modify the JSONObject. Use with caution.
      Returns:
        A keySet.
      See Also:
        `Map.keySet()`

    - #### entrySet

          protected Set<Map.Entry<String,​Object>> entrySet()

      Get a set of entries of the JSONObject. These are raw values and may not match what is returned by the JSONObject get* and opt* functions. Modifying the returned EntrySet or the Entry objects contained therein will modify the backing JSONObject. This does not return a clone or a read-only view. Use with caution.
      Returns:
        An Entry Set
      See Also:
        `Map.entrySet()`

    - #### length

          public int length()

      Get the number of keys stored in the JSONObject.
      Returns:
        The number of keys in the JSONObject.

    - #### clear

          public void clear()

      Removes all of the elements from this JSONObject. The JSONObject will be empty after this call returns.

    - #### isEmpty

          public boolean isEmpty()

      Check if JSONObject is empty.
      Returns:
        true if JSONObject is empty, otherwise false.

    - #### names

          public JSONArray names()

      Produce a JSONArray containing the names of the elements of this JSONObject.
      Returns:
        A JSONArray containing the key strings, or null if the JSONObject is empty.

    - #### numberToString

          public static String numberToString​(Number number)
                                       throws JSONException

      Produce a string from a Number.
      Parameters:
        `number` - A Number
      Returns:
        A String.
      Throws:
        `JSONException` - If n is a non-finite number.

    - #### opt

          public Object opt​(String key)

      Get an optional value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        An object which is the value, or null if there is no value.

    - #### optEnum

          public <E extends Enum<E>> E optEnum​(Class<E> clazz,
                                               String key)

      Get the enum value associated with a key.
      Type Parameters:
        `E` - Enum Type
      Parameters:
        `clazz` - The type of enum to retrieve.
        `key` - A key string.
      Returns:
        The enum value associated with the key or null if not found

    - #### optEnum

          public <E extends Enum<E>> E optEnum​(Class<E> clazz,
                                               String key,
                                               E defaultValue)

      Get the enum value associated with a key.
      Type Parameters:
        `E` - Enum Type
      Parameters:
        `clazz` - The type of enum to retrieve.
        `key` - A key string.
        `defaultValue` - The default in case the value is not found
      Returns:
        The enum value associated with the key or defaultValue if the value is not found or cannot be assigned to `clazz`

    - #### optBoolean

          public boolean optBoolean​(String key)

      Get an optional boolean associated with a key. It returns false if there is no such key, or if the value is not Boolean.TRUE or the String "true".
      Parameters:
        `key` - A key string.
      Returns:
        The truth.

    - #### optBoolean

          public boolean optBoolean​(String key,
                                    boolean defaultValue)

      Get an optional boolean associated with a key. It returns the defaultValue if there is no such key, or if it is not a Boolean or the String "true" or "false" (case insensitive).
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        The truth.

    - #### optBooleanObject

          public Boolean optBooleanObject​(String key)

      Get an optional boolean object associated with a key. It returns false if there is no such key, or if the value is not Boolean.TRUE or the String "true".
      Parameters:
        `key` - A key string.
      Returns:
        The truth.

    - #### optBooleanObject

          public Boolean optBooleanObject​(String key,
                                          Boolean defaultValue)

      Get an optional boolean object associated with a key. It returns the defaultValue if there is no such key, or if it is not a Boolean or the String "true" or "false" (case insensitive).
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        The truth.

    - #### optBigDecimal

          public BigDecimal optBigDecimal​(String key,
                                          BigDecimal defaultValue)

      Get an optional BigDecimal associated with a key, or the defaultValue if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number. If the value is float or double, then the `BigDecimal(double)` constructor will be used. See notes on the constructor for conversion issues that may arise.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optBigInteger

          public BigInteger optBigInteger​(String key,
                                          BigInteger defaultValue)

      Get an optional BigInteger associated with a key, or the defaultValue if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optDouble

          public double optDouble​(String key)

      Get an optional double associated with a key, or NaN if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A string which is the key.
      Returns:
        An object which is the value.

    - #### optDouble

          public double optDouble​(String key,
                                  double defaultValue)

      Get an optional double associated with a key, or the defaultValue if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optDoubleObject

          public Double optDoubleObject​(String key)

      Get an optional Double object associated with a key, or NaN if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A string which is the key.
      Returns:
        An object which is the value.

    - #### optDoubleObject

          public Double optDoubleObject​(String key,
                                        Double defaultValue)

      Get an optional Double object associated with a key, or the defaultValue if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optFloat

          public float optFloat​(String key)

      Get the optional float value associated with an index. NaN is returned if there is no value for the index, or if the value is not a number and cannot be converted to a number.
      Parameters:
        `key` - A key string.
      Returns:
        The value.

    - #### optFloat

          public float optFloat​(String key,
                                float defaultValue)

      Get the optional float value associated with an index. The defaultValue is returned if there is no value for the index, or if the value is not a number and cannot be converted to a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default value.
      Returns:
        The value.

    - #### optFloatObject

          public Float optFloatObject​(String key)

      Get the optional Float object associated with an index. NaN is returned if there is no value for the index, or if the value is not a number and cannot be converted to a number.
      Parameters:
        `key` - A key string.
      Returns:
        The object.

    - #### optFloatObject

          public Float optFloatObject​(String key,
                                      Float defaultValue)

      Get the optional Float object associated with an index. The defaultValue is returned if there is no value for the index, or if the value is not a number and cannot be converted to a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default object.
      Returns:
        The object.

    - #### optInt

          public int optInt​(String key)

      Get an optional int value associated with a key, or zero if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
      Returns:
        An object which is the value.

    - #### optInt

          public int optInt​(String key,
                            int defaultValue)

      Get an optional int value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optIntegerObject

          public Integer optIntegerObject​(String key)

      Get an optional Integer object associated with a key, or zero if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
      Returns:
        An object which is the value.

    - #### optIntegerObject

          public Integer optIntegerObject​(String key,
                                          Integer defaultValue)

      Get an optional Integer object associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optJSONArray

          public JSONArray optJSONArray​(String key)

      Get an optional JSONArray associated with a key. It returns null if there is no such key, or if its value is not a JSONArray.
      Parameters:
        `key` - A key string.
      Returns:
        A JSONArray which is the value.

    - #### optJSONArray

          public JSONArray optJSONArray​(String key,
                                        JSONArray defaultValue)

      Get an optional JSONArray associated with a key, or the default if there is no such key, or if its value is not a JSONArray.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        A JSONArray which is the value.

    - #### optJSONObject

          public JSONObject optJSONObject​(String key)

      Get an optional JSONObject associated with a key. It returns null if there is no such key, or if its value is not a JSONObject.
      Parameters:
        `key` - A key string.
      Returns:
        A JSONObject which is the value.

    - #### optJSONObject

          public JSONObject optJSONObject​(String key,
                                          JSONObject defaultValue)

      Get an optional JSONObject associated with a key, or the default if there is no such key or if the value is not a JSONObject.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An JSONObject which is the value.

    - #### optLong

          public long optLong​(String key)

      Get an optional long value associated with a key, or zero if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
      Returns:
        An object which is the value.

    - #### optLong

          public long optLong​(String key,
                              long defaultValue)

      Get an optional long value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optLongObject

          public Long optLongObject​(String key)

      Get an optional Long object associated with a key, or zero if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
      Returns:
        An object which is the value.

    - #### optLongObject

          public Long optLongObject​(String key,
                                    Long defaultValue)

      Get an optional Long object associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optNumber

          public Number optNumber​(String key)

      Get an optional `Number` value associated with a key, or `null` if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number (`BigDecimal`). This method would be used in cases where type coercion of the number value is unwanted.
      Parameters:
        `key` - A key string.
      Returns:
        An object which is the value.

    - #### optNumber

          public Number optNumber​(String key,
                                  Number defaultValue)

      Get an optional `Number` value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number. This method would be used in cases where type coercion of the number value is unwanted.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### optString

          public String optString​(String key)

      Get an optional string associated with a key. It returns an empty string if there is no such key. If the value is not a string and is not null, then it is converted to a string.
      Parameters:
        `key` - A key string.
      Returns:
        A string which is the value.

    - #### optString

          public String optString​(String key,
                                  String defaultValue)

      Get an optional string associated with a key. It returns the defaultValue if there is no such key.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        A string which is the value.

    - #### put

          public JSONObject put​(String key,
                                boolean value)
                         throws JSONException

      Put a key/boolean pair in the JSONObject.
      Parameters:
        `key` - A key string.
        `value` - A boolean which is the value.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### put

          public JSONObject put​(String key,
                                Collection<?> value)
                         throws JSONException

      Put a key/value pair in the JSONObject, where the value will be a JSONArray which is produced from a Collection.
      Parameters:
        `key` - A key string.
        `value` - A Collection value.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### put

          public JSONObject put​(String key,
                                double value)
                         throws JSONException

      Put a key/double pair in the JSONObject.
      Parameters:
        `key` - A key string.
        `value` - A double which is the value.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### put

          public JSONObject put​(String key,
                                float value)
                         throws JSONException

      Put a key/float pair in the JSONObject.
      Parameters:
        `key` - A key string.
        `value` - A float which is the value.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### put

          public JSONObject put​(String key,
                                int value)
                         throws JSONException

      Put a key/int pair in the JSONObject.
      Parameters:
        `key` - A key string.
        `value` - An int which is the value.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### put

          public JSONObject put​(String key,
                                long value)
                         throws JSONException

      Put a key/long pair in the JSONObject.
      Parameters:
        `key` - A key string.
        `value` - A long which is the value.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### put

          public JSONObject put​(String key,
                                Map<?,​?> value)
                         throws JSONException

      Put a key/value pair in the JSONObject, where the value will be a JSONObject which is produced from a Map.
      Parameters:
        `key` - A key string.
        `value` - A Map value.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### put

          public JSONObject put​(String key,
                                Object value)
                         throws JSONException

      Put a key/value pair in the JSONObject. If the value is `null`, then the key will be removed from the JSONObject if it is present.
      Parameters:
        `key` - A key string.
        `value` - An object which is the value. It should be of one of these types: Boolean, Double, Integer, JSONArray, JSONObject, Long, String, or the JSONObject.NULL object.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is non-finite number.
        `NullPointerException` - If the key is `null`.

    - #### putOnce

          public JSONObject putOnce​(String key,
                                    Object value)
                             throws JSONException

      Put a key/value pair in the JSONObject, but only if the key and the value are both non-null, and only if there is not already a member with that name.
      Parameters:
        `key` - key to insert into
        `value` - value to insert
      Returns:
        this.
      Throws:
        `JSONException` - if the key is a duplicate

    - #### putOpt

          public JSONObject putOpt​(String key,
                                   Object value)
                            throws JSONException

      Put a key/value pair in the JSONObject, but only if the key and the value are both non-null.
      Parameters:
        `key` - A key string.
        `value` - An object which is the value. It should be of one of these types: Boolean, Double, Integer, JSONArray, JSONObject, Long, String, or the JSONObject.NULL object.
      Returns:
        this.
      Throws:
        `JSONException` - If the value is a non-finite number.

    - #### query

          public Object query​(String jsonPointer)

      Creates a JSONPointer using an initialization string and tries to match it to an item within this JSONObject. For example, given a JSONObject initialized with this document:

           {
               "a":{"b":"c"}
           }

      and this JSONPointer string:

           "/a/b"

      Then this method will return the String "c". A JSONPointerException may be thrown from code called by this method.
      Parameters:
        `jsonPointer` - string that can be used to create a JSONPointer
      Returns:
        the item matched by the JSONPointer, otherwise null

    - #### query

          public Object query​(JSONPointer jsonPointer)

      Uses a user initialized JSONPointer and tries to match it to an item within this JSONObject. For example, given a JSONObject initialized with this document:

           {
               "a":{"b":"c"}
           }

      and this JSONPointer:

           "/a/b"

      Then this method will return the String "c". A JSONPointerException may be thrown from code called by this method.
      Parameters:
        `jsonPointer` - string that can be used to create a JSONPointer
      Returns:
        the item matched by the JSONPointer, otherwise null

    - #### optQuery

          public Object optQuery​(String jsonPointer)

      Queries and returns a value from this object using `jsonPointer`, or returns null if the query fails due to a missing key.
      Parameters:
        `jsonPointer` - the string representation of the JSON pointer
      Returns:
        the queried value or `null`
      Throws:
        `IllegalArgumentException` - if `jsonPointer` has invalid syntax

    - #### optQuery

          public Object optQuery​(JSONPointer jsonPointer)

      Queries and returns a value from this object using `jsonPointer`, or returns null if the query fails due to a missing key.
      Parameters:
        `jsonPointer` - The JSON pointer
      Returns:
        the queried value or `null`
      Throws:
        `IllegalArgumentException` - if `jsonPointer` has invalid syntax

    - #### quote

          public static String quote​(String string)

      Produce a string in double quotes with backslash sequences in all the right places. A backslash will be inserted within </, producing <\/, allowing JSON text to be delivered in HTML. In JSON text, a string cannot contain a control character or an unescaped quote or backslash.
      Parameters:
        `string` - A String
      Returns:
        A String correctly formatted for insertion in a JSON text.

    - #### quote

          public static Writer quote​(String string,
                                     Writer w)
                              throws IOException

      Throws:
        `IOException`

    - #### remove

          public Object remove​(String key)

      Remove a name and its value, if present.
      Parameters:
        `key` - The name to be removed.
      Returns:
        The value that was associated with the name, or null if there was no value.

    - #### similar

          public boolean similar​(Object other)

      Determine if two JSONObjects are similar. They must contain the same set of names which must be associated with similar values.
      Parameters:
        `other` - The other JSONObject
      Returns:
        true if they are equal

    - #### isDecimalNotation

          protected static boolean isDecimalNotation​(String val)

      Tests if the value should be tried as a decimal. It makes no test if there are actual digits.
      Parameters:
        `val` - value to test
      Returns:
        true if the string is "-0" or if it contains '.', 'e', or 'E', false otherwise.

    - #### stringToValue

          public static Object stringToValue​(String string)

      Try to convert a string into a number, boolean, or null. If the string can't be converted, return the string.
      Parameters:
        `string` - A String. can not be null.
      Returns:
        A simple JSON value.
      Throws:
        `NullPointerException` - Thrown if the string is null.

    - #### testValidity

          public static void testValidity​(Object o)
                                   throws JSONException

      Throw an exception if the object is a NaN or infinite number.
      Parameters:
        `o` - The object to test.
      Throws:
        `JSONException` - If o is a non-finite number.

    - #### toJSONArray

          public JSONArray toJSONArray​(JSONArray names)
                                throws JSONException

      Produce a JSONArray containing the values of the members of this JSONObject.
      Parameters:
        `names` - A JSONArray containing a list of key strings. This determines the sequence of the values in the result.
      Returns:
        A JSONArray of values.
      Throws:
        `JSONException` - If any of the values are non-finite numbers.

    - #### toString

          public String toString()

      Make a JSON text of this JSONObject. For compactness, no whitespace is added. If this would not result in a syntactically correct JSON text, then null will be returned instead.

      Warning: This method assumes that the data structure is acyclical.

      Overrides:
        `toString` in class `Object`
      Returns:
        a printable, displayable, portable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).

    - #### toString

          public String toString​(int indentFactor)
                          throws JSONException

      Make a pretty-printed JSON text of this JSONObject.

      If

          indentFactor > 0

      and the `JSONObject` has only one key, then the object will be output on a single line:

          {"key": 1}

      If an object has 2 or more keys, then it will be output across multiple lines:

          {
            "key1": 1,
            "key2": "value 2",
            "key3": 3
           }

      Warning: This method assumes that the data structure is acyclical.

      Parameters:
        `indentFactor` - The number of spaces to add to each level of indentation.
      Returns:
        a printable, displayable, portable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).
      Throws:
        `JSONException` - If the object contains an invalid number.

    - #### valueToString

          public static String valueToString​(Object value)
                                      throws JSONException

      Make a JSON text of an Object value. If the object has an value.toJSONString() method, then that method will be used to produce the JSON text. The method is required to produce a strictly conforming text. If the object does not contain a toJSONString method (which is the most common case), then a text will be produced by other means. If the value is an array or Collection, then a JSONArray will be made from it and its toJSONString method will be called. If the value is a MAP, then a JSONObject will be made from it and its toJSONString method will be called. Otherwise, the value's toString method will be called, and the result will be quoted.

      Warning: This method assumes that the data structure is acyclical.

      Parameters:
        `value` - The value to be serialized.
      Returns:
        a printable, displayable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).
      Throws:
        `JSONException` - If the value is or contains an invalid number.

    - #### wrap

          public static Object wrap​(Object object)

      Wrap an object, if necessary. If the object is `null`, return the NULL object. If it is an array or collection, wrap it in a JSONArray. If it is a map, wrap it in a JSONObject. If it is a standard property (Double, String, et al) then it is already wrapped. Otherwise, if it comes from one of the java packages, turn it into a string. And if it doesn't, try to wrap it in a JSONObject. If the wrapping fails, then null is returned.
      Parameters:
        `object` - The object to wrap
      Returns:
        The wrapped value

    - #### write

          public Writer write​(Writer writer)
                       throws JSONException

      Write the contents of the JSONObject as JSON text to a writer. For compactness, no whitespace is added.

      Warning: This method assumes that the data structure is acyclical.

      Parameters:
        `writer` - the writer object
      Returns:
        The writer.
      Throws:
        `JSONException` - if a called function has an error

    - #### write

          public Writer write​(Writer writer,
                              int indentFactor,
                              int indent)
                       throws JSONException

      Write the contents of the JSONObject as JSON text to a writer.

      If

          indentFactor > 0

      and the `JSONObject` has only one key, then the object will be output on a single line:

          {"key": 1}

      If an object has 2 or more keys, then it will be output across multiple lines:

          {
            "key1": 1,
            "key2": "value 2",
            "key3": 3
           }

      Warning: This method assumes that the data structure is acyclical.

      Parameters:
        `writer` - Writes the serialized JSON
        `indentFactor` - The number of spaces to add to each level of indentation.
        `indent` - The indentation of the top level.
      Returns:
        The writer.
      Throws:
        `JSONException` - if a called function has an error or a write error occurs

    - #### toMap

          public Map<String,​Object> toMap()

      Returns a java.util.Map containing all of the entries in this object. If an entry in the object is a JSONArray or JSONObject it will also be converted.

      Warning: This method assumes that the data structure is acyclical.

      Returns:
        a java.util.Map containing the entries of this object